"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _util = require("./util");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var doubleDigits = function doubleDigits(number) {
  return _ramda2.default.takeLast(2, "0" + number);
};

/**
 * A Date object.
 */

var DateComponent = function (_React$Component) {
  _inherits(DateComponent, _React$Component);

  function DateComponent() {
    _classCallCheck(this, DateComponent);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(DateComponent).apply(this, arguments));
  }

  _createClass(DateComponent, [{
    key: "render",
    value: function render() {
      var _props = this.props;
      var value = _props.value;
      var italic = _props.italic;
      var size = _props.size;

      var textProps = { italic: italic, size: size };

      // Date.
      var year = value.getUTCFullYear();
      var month = doubleDigits(value.getUTCMonth() + 1);
      var day = doubleDigits(value.getUTCDate());

      // Time.
      var hours = value.getHours();
      var minutes = doubleDigits(value.getMinutes());
      var seconds = doubleDigits(value.getSeconds());
      var period = hours > 11 ? "pm" : "am";
      if (hours > 12) {
        hours = hours - 12;
      }

      return _react2.default.createElement(
        "span",
        null,
        _react2.default.createElement(
          _Text2.default,
          _extends({}, textProps, { color: "blue" }),
          year + "-" + month + "-" + day + ",",
          hours + ":" + minutes + ":" + seconds + period
        )
      );
    }
  }]);

  return DateComponent;
}(_react2.default.Component);

DateComponent.propTypes = {
  value: _util.PropTypes.instanceOf(Date).isRequired,
  italic: _Text2.default.propTypes.italic,
  size: _Text2.default.propTypes.size
};
DateComponent.defaultProps = {
  italic: true,
  size: _Text2.default.defaultProps.size
};
exports.default = DateComponent;