"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _util = require("./util");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

var _jsUtil = require("js-util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * A Function with parameters details.
 */

var Function = function (_React$Component) {
  _inherits(Function, _React$Component);

  function Function() {
    _classCallCheck(this, Function);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Function).apply(this, arguments));
  }

  _createClass(Function, [{
    key: "render",
    value: function render() {
      var _props = this.props;
      var value = _props.value;
      var size = _props.size;

      var textProps = { italic: true, size: size };
      var name = value.name;

      name = name === "value" ? "function" : name;
      var elName = name && _react2.default.createElement(
        _Text2.default,
        _extends({}, textProps, { color: "blue" }),
        name
      );
      var params = [];
      var paramNames = (0, _jsUtil.functionParameters)(value);
      paramNames.forEach(function (paramName, i) {
        var isLast = i === paramNames.length - 1;
        params.push(_react2.default.createElement(
          _Text2.default,
          _extends({ key: i }, textProps, { color: "red" }),
          paramName
        ));
        if (!isLast) {
          params.push(_react2.default.createElement(
            _Text2.default,
            _extends({ key: i + "comma" }, textProps, { marginRight: 6 }),
            ","
          ));
        }
      });

      return _react2.default.createElement(
        "span",
        null,
        elName,
        _react2.default.createElement(
          _Text2.default,
          textProps,
          "("
        ),
        params,
        _react2.default.createElement(
          _Text2.default,
          textProps,
          ")"
        )
      );
    }
  }]);

  return Function;
}(_react2.default.Component);

Function.propTypes = {
  value: _util.PropTypes.func.isRequired,
  size: _Text2.default.propTypes.size
};
Function.defaultProps = {
  size: _Text2.default.defaultProps.size
};
exports.default = Function;