"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPrimitive = undefined;

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _util = require("./util");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var COLORS = {
  "Null": "lightGrey",
  "Undefined": "lightGrey",
  "String": "red",
  "Number": "blue",
  "Boolean": "blue"
};

/**
 * Determines whether the given value is primitive.
 */
var isPrimitive = exports.isPrimitive = function isPrimitive(value) {
  if (_ramda2.default.isNil(value)) {
    return true;
  } else {
    var isType = function isType(type) {
      return _ramda2.default.is(type, value);
    };
    return _ramda2.default.any(isType, [String, Number, Boolean]);
  }
};

/**
 * A primitive/simple value.
 */

var Primitive = function (_React$Component) {
  _inherits(Primitive, _React$Component);

  function Primitive() {
    _classCallCheck(this, Primitive);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Primitive).apply(this, arguments));
  }

  _createClass(Primitive, [{
    key: "render",
    value: function render() {
      var value = this.props.value;

      var type = _ramda2.default.type(value);
      switch (type) {
        case "Undefined":
          value = "<undefined>";break;
        case "Null":
          value = "<null>";break;
        case "Boolean":
          value = value.toString();break;
        case "String":
          value = "“" + value + "”";break;
      }
      return _react2.default.createElement(
        _Text2.default,
        _extends({ color: COLORS[type] }, this.props),
        value
      );
    }
  }]);

  return Primitive;
}(_react2.default.Component);

Primitive.propTypes = {
  value: _util.PropTypes.oneOfType([_util.PropTypes.string, _util.PropTypes.number, _util.PropTypes.bool]),
  italic: _Text2.default.propTypes.italic,
  size: _Text2.default.propTypes.size
};
Primitive.defaultProps = {
  italic: _Text2.default.defaultProps.italic,
  size: _Text2.default.defaultProps.size
};
exports.default = Primitive;