"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.COLORS = exports.FONT_MONO = undefined;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FONT_MONO = exports.FONT_MONO = "Menlo, monospace";
var COLORS = exports.COLORS = {
  black: "#000",
  darkGrey: "#303942",
  grey: "#999999",
  lightGrey: "#C8C8C8",
  red: "#C9214C",
  brown: "#9B4500",
  green: "#007500",
  blue: "#180AA9",
  purple: "#AC0093"
};

/**
 * Text display with commonly used style properties.
 */

var Text = function (_React$Component) {
  _inherits(Text, _React$Component);

  function Text() {
    _classCallCheck(this, Text);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Text).apply(this, arguments));
  }

  _createClass(Text, [{
    key: "styles",
    value: function styles() {
      return (0, _util.css)({
        base: {
          fontFamily: FONT_MONO,
          fontSize: this.props.size,
          fontWeight: "normal",
          fontStyle: this.props.italic === true ? "italic" : "normal",
          lineHeight: this.props.lineHeight,
          color: COLORS[this.props.color],
          marginLeft: this.props.marginLeft,
          marginRight: this.props.marginRight,
          cursor: this.props.onClick ? "pointer" : null,
          letterSpacing: this.props.letterSpacing
        }
      });
    }
  }, {
    key: "handleClick",
    value: function handleClick(e) {
      var onClick = this.props.onClick;

      if (onClick) {
        onClick({ args: e });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var styles = this.styles();
      var handleClick = this.handleClick.bind(this);
      return this.props.inline ? _react2.default.createElement(
        "span",
        { style: styles.base, onClick: handleClick },
        this.props.children
      ) : _react2.default.createElement(
        "div",
        { style: styles.base, onClick: handleClick },
        this.props.children
      );
    }
  }]);

  return Text;
}(_react2.default.Component);

Text.propTypes = {
  inline: _util.PropTypes.bool,
  italic: _util.PropTypes.bool,
  size: _util.PropTypes.numberOrString,
  color: _util.PropTypes.oneOf(Object.keys(COLORS)),
  marginLeft: _util.PropTypes.numberOrString,
  marginRight: _util.PropTypes.numberOrString,
  letterSpacing: _util.PropTypes.numberOrString,
  lineHeight: _util.PropTypes.numberOrString,
  onClick: _util.PropTypes.func
};
Text.defaultProps = {
  inline: true,
  italic: false,
  size: 12,
  color: "darkGrey",
  marginLeft: 0,
  marginRight: 0,
  letterSpacing: "normal",
  lineHeight: "1.4em"
};
exports.default = (0, _radium2.default)(Text);