"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require("ramda");

var _ramda2 = _interopRequireDefault(_ramda);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _util = require("./util");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

var _Twisty = require("react-atoms/components/Twisty");

var _Twisty2 = _interopRequireDefault(_Twisty);

var _Primitive = require("./Primitive");

var _Primitive2 = _interopRequireDefault(_Primitive);

var _Complex = require("./Complex");

var _Complex2 = _interopRequireDefault(_Complex);

var _Function = require("./Function");

var _Function2 = _interopRequireDefault(_Function);

var _Date = require("./Date");

var _Date2 = _interopRequireDefault(_Date);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint no-unused-vars: 0 */

/**
 * A single value of any type (with optional key and expansion toggle).
 */

var Value = function (_React$Component) {
  _inherits(Value, _React$Component);

  function Value() {
    _classCallCheck(this, Value);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Value).apply(this, arguments));
  }

  _createClass(Value, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      this.setState({ isExpanded: this.props.isExpanded });
    } // The number of {object} properties to show when not expanded.

  }, {
    key: "styles",
    value: function styles() {
      var _props = this.props;
      var inline = _props.inline;
      var value = _props.value;
      var isExpanded = this.state.isExpanded;

      var showTwisty = this.showTwisty();
      var twistyWidth = 10;
      var indent = showTwisty === true ? twistyWidth + 2 : 0;
      var canExpand = showTwisty && !isExpanded && !this.isPrimitive() && !(0, _util.isEmptyObjectOrArray)(value);

      return (0, _util.css)({
        base: {
          position: "relative",
          paddingLeft: indent,
          display: inline ? "inline-block" : null,
          marginLeft: this.props.marginLeft,
          marginRight: this.props.marginRight,
          cursor: canExpand ? "pointer" : null
        },
        twistyOuter: {
          Absolute: [0, null, null, 0],
          width: twistyWidth,
          fontSize: this.props.size,
          lineHeight: _Text2.default.defaultProps.lineHeight
        },
        twistyAlign: {
          AbsoluteCenter: "y",
          width: twistyWidth
        }
      });
    }
  }, {
    key: "isPrimitive",
    value: function isPrimitive() {
      return (0, _Primitive.isPrimitive)(this.props.value);
    }
  }, {
    key: "showTwisty",
    value: function showTwisty() {
      var result = this.props.showTwisty;
      if (result === undefined) {
        var value = this.props.value;

        if (!(0, _Primitive.isPrimitive)(value) && !(0, _util.isEmptyObjectOrArray)(value)) {
          result = true;
        }
      }
      return result;
    }
  }, {
    key: "handleToggleClick",
    value: function handleToggleClick(e) {
      this.setState({ isExpanded: !this.state.isExpanded });
    }
  }, {
    key: "render",
    value: function render() {
      var styles = this.styles();
      var _props2 = this.props;
      var label = _props2.label;
      var italic = _props2.italic;
      var size = _props2.size;
      var value = _props2.value;
      var level = _props2.level;
      var isExpanded = this.state.isExpanded;

      var textStyles = { italic: italic, size: size };
      var IS_PRIMITIVE = this.isPrimitive();
      var showTwisty = this.showTwisty();

      if ((0, _util.isEmptyObjectOrArray)(value)) {
        showTwisty = false;
      }

      var elTwisty = undefined,
          handleToggleClick = undefined;
      if (showTwisty === true && !IS_PRIMITIVE) {
        handleToggleClick = this.handleToggleClick.bind(this);
        // NB: Add the "zero width non-joiner" (\u200C) character to force the
        //     height of the twisty container to the height of the label.
        elTwisty = _react2.default.createElement(
          "div",
          { style: styles.twistyOuter },
          _react2.default.createElement(
            "div",
            { style: styles.twistyAlign },
            _react2.default.createElement(_Twisty2.default, {
              isOpen: isExpanded,
              onClick: handleToggleClick
            })
          ),
          "‌"
        );
      }

      var elLabel = label && _react2.default.createElement(
        _Text2.default,
        _extends({
          color: "purple",
          onClick: handleToggleClick
        }, textStyles),
        label
      );

      var elValue = undefined;
      if (IS_PRIMITIVE) {
        // Simple value (string, number, bool).
        elValue = _react2.default.createElement(_Primitive2.default, _extends({ value: value }, textStyles));
      } else {
        // Complex value (object, array).
        if (_ramda2.default.is(Function, value)) {
          elValue = _react2.default.createElement(_Function2.default, _extends({}, textStyles, { value: value }));
        } else if (_ramda2.default.is(Date, value)) {
          elValue = _react2.default.createElement(_Date2.default, _extends({}, textStyles, { value: value }));
        } else {
          elValue = _react2.default.createElement(_Complex2.default, _extends({}, textStyles, {
            value: value,
            level: level,
            label: level === 0,
            isExpanded: isExpanded,
            collapsedTotal: this.props.collapsedTotal
          }));
        }
      }

      return _react2.default.createElement(
        "div",
        { style: styles.base, onClick: !isExpanded && handleToggleClick },
        elTwisty,
        elLabel,
        elLabel && _react2.default.createElement(
          _Text2.default,
          _extends({}, textStyles, { marginRight: 4 }),
          ":"
        ),
        elValue
      );
    }
  }]);

  return Value;
}(_react2.default.Component);

Value.propTypes = {
  value: _util.PropTypes.any,
  label: _util.PropTypes.string,
  italic: _Text2.default.propTypes.italic,
  size: _Text2.default.propTypes.size,
  inline: _util.PropTypes.bool,
  level: _util.PropTypes.number,
  isExpanded: _util.PropTypes.bool,
  showTwisty: _util.PropTypes.bool,
  marginLeft: _util.PropTypes.numberOrString,
  marginRight: _util.PropTypes.numberOrString,
  collapsedTotal: _util.PropTypes.number };
Value.defaultProps = {
  italic: _Text2.default.defaultProps.italic,
  size: _Text2.default.defaultProps.size,
  inline: false,
  level: 0,
  isExpanded: false,
  marginLeft: 0,
  marginRight: 0
};
exports.default = (0, _radium2.default)(Value);