"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ELLIPSIS = undefined;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _radium = require("radium");

var _radium2 = _interopRequireDefault(_radium);

var _Ellipsis = require("./Ellipsis");

var _Ellipsis2 = _interopRequireDefault(_Ellipsis);

var _util = require("./util");

var _Text = require("./Text");

var _Text2 = _interopRequireDefault(_Text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint no-unused-vars: 0 */

var Value = undefined; // NB: Lazily required to prevent circular-reference.

var ELLIPSIS = exports.ELLIPSIS = Symbol("ellipsis");

/**
 * A list of <Value>'s.
 */

var ValueList = function (_React$Component) {
  _inherits(ValueList, _React$Component);

  function ValueList(props) {
    _classCallCheck(this, ValueList);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ValueList).call(this, props));

    if (!Value) {
      Value = require("./Value").default; // NB: Lazily required to prevent circular-reference.
    }
    return _this;
  } // The number of {object} properties to show when not expanded.

  _createClass(ValueList, [{
    key: "styles",
    value: function styles() {
      var inline = this.props.inline;

      return (0, _util.css)({
        base: {
          display: inline ? "inline-block" : null,
          listStyleType: "none",
          margin: 0,
          paddingTop: 0,
          paddingRight: 0,
          paddingBottom: 0,
          paddingLeft: inline ? 0 : "0.2em",
          fontSize: this.props.size,
          fontStyle: this.props.italic ? "italic" : "normal"
        },
        li: {
          display: this.props.inline ? "inline" : null
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var styles = this.styles();
      var _props = this.props;
      var inline = _props.inline;
      var size = _props.size;
      var italic = _props.italic;

      var textStyles = { italic: italic, size: size };
      var total = this.props.items.length;
      var items = [];
      this.props.items.forEach(function (item, i) {
        // Insert the <Value>.
        var isLast = i === total - 1;
        var isEllipsis = item === ELLIPSIS;
        var isNextEllipsis = _this2.props.items[i + 1] === ELLIPSIS;
        var el = isEllipsis ? _react2.default.createElement(_Ellipsis2.default, _extends({}, textStyles, {
          marginLeft: inline ? isLast ? 0 : 6 : 12,
          marginRight: inline && !isLast ? 6 : 0 })) : _react2.default.createElement(Value, _extends({}, textStyles, {
          label: item.label,
          value: item.value,
          level: _this2.props.level + 1,
          isExpanded: false,
          inline: _this2.props.inline,
          showTwisty: !inline,
          collapsedTotal: _this2.props.collapsedTotal }));
        items.push(_react2.default.createElement(
          "li",
          { key: i, style: styles.li },
          el
        ));

        // Inert dividing comma.
        if (inline && !isLast && !isEllipsis && !isNextEllipsis) {
          items.push(_react2.default.createElement(
            _Text2.default,
            _extends({
              key: i + "-comma"
            }, textStyles, {
              color: "darkGrey",
              marginRight: 8 }),
            ","
          ));
        }
      });

      return _react2.default.createElement(
        "ul",
        { style: styles.base },
        items
      );
    }
  }]);

  return ValueList;
}(_react2.default.Component);

ValueList.propTypes = {
  inline: _util.PropTypes.bool,
  italic: _Text2.default.propTypes.italic,
  size: _Text2.default.propTypes.size,
  items: _util.PropTypes.array,
  level: _util.PropTypes.number,
  collapsedTotal: _util.PropTypes.number };
ValueList.defaultProps = {
  inline: false,
  italic: _Text2.default.defaultProps.italic,
  size: _Text2.default.defaultProps.size,
  items: [],
  level: 0
};
exports.default = (0, _radium2.default)(ValueList);